# import csv
import numpy as np
from numpy import *
import matplotlib.pyplot as plt
from mpl_toolkits import mplot3d
'''
import os.path
save_path = '/home/multigrid/Master Thesis/LayerParallelLearning/examples/function'
completeName = os.path.join(save_path, name_of_file+".dat")
'''

''' For Function Learning: Features- (x,y), to learn- f(x,y) '''

# Generate training and testing data features(x,y)
training_size = 1000
x_train = np.random.uniform(0.0, 1.0, training_size)
y_train = np.random.uniform(0.0, 1.0, training_size)

testing_size = 200
x_test = np.random.uniform(0.0, 1.0, testing_size)
y_test = np.random.uniform(0.0, 1.0, testing_size)

# Function to be learned: (a)x**2 +(b)y**2 + (c)xy + (d)x + (e)y  + (f)1

# Set coefficients
coefficients = [1.0, 1.0, 0., 0., 0., 0.]

# stack up vectors x**2, y**y, xy, x, y, 1 all of data_size
Arr_train = np.transpose(np.vstack((np.power(x_train, 2), np.power(y_train, 2), x_train * y_train,  x_train, y_train, np.ones(training_size))).reshape(len(coefficients), training_size))
Arr_test  = np.transpose(np.vstack((np.power(x_test, 2), np.power(y_test, 2), x_test * y_test,  x_test, y_test, np.ones(testing_size))).reshape(len(coefficients), testing_size))

# Generate the training and testing data output in seperate files
output_train = np.matmul(Arr_train, coefficients)
output_test = np.matmul(Arr_test, coefficients)

# Writing the training and validation data into files
# Training Data Files
features_train = column_stack((x_train, y_train))
savetxt('features_training.dat', features_train)
savetxt('output_training.dat', output_train)

# Validation Data Files
features_validation = column_stack((x_test, y_test))
savetxt('features_validation.dat', features_validation)
savetxt('output_validation.dat', output_test)

'''
regression_train = column_stack(output_train)

regression_validation = column_stack(output_test)
savetxt('output_validation.dat', regression_validation)

'''
# Plotting routines
'''
ax = plt.axes(projection='3d')
ax.scatter3D(x_train, y_train, output_train, c=output_train, cmap='Greens');
ax.set_xlabel('x')
ax.set_ylabel('y')
ax.set_zlabel('f(x,y')
plt.show()
'''

