import csv
import numpy as np
from numpy import *
import matplotlib.pyplot as plt
from mpl_toolkits import mplot3d
import random
from mpl_toolkits.mplot3d import Axes3D
'''
import os.path
save_path = '/home/multigrid/Master Thesis/LayerParallelLearning/examples/function'
completeName = os.path.join(save_path, name_of_file+".dat")
'''

''' For Function Learning: Features- (x,y), to learn- f(x,y) '''

# Generate training and testing data features(x,y)
training_size = 5000
testing_size = 400

# Create and store the grid: Specify domain and grid size
nx, ny = (20, 20)
x = np.linspace(-1., 1., nx)
y = np.linspace(-1., 1., ny)
# xx, yy = np.meshgrid(x, y, sparse=True)
xx, yy = np.meshgrid(x, y)

    
def ax2plusby2(x, y):
    a = random.uniform(-100.0, 100.0)
    b = random.uniform(-100.0, 100.0)
    xx_sq = (x ** 2)
    yy_sq = (y ** 2)
    return a * xx_sq + b * yy_sq


def poisson(x, y):
    k = random.uniform(-5.0, 5.0)
    l = random.uniform(-5.0, 5.0)
    return np.sin(k * x) * np.cos(l * y)

def set_features(f):
    Left, Right = f[1:-1:1, 0], f[1:-1:1, -1]
    Bottom, Top = f[0, :], f[-1, :]
    boundary = np.hstack((Bottom, Left, Right, Top))
    return np.reshape(boundary, (1, len(boundary)))


def set_interior(f):
    return np.reshape(f[1:-1:1, 1:-1:1], (1, (nx - 2) * (ny - 2)))

with open('features_training.dat', 'a') as f1:
    with open('output_training.dat', 'a') as f2:
        with open('features_validation.dat', 'a') as f3:
            with open('output_validation.dat', 'a') as f4:
                for i in range(training_size + testing_size):
                    # Calc the analytical solution on the grid
                    f_nodes = poisson(xx, yy)

                    # Set the features as BCs (Input to the network)
                    features = set_features(f_nodes)

                    # Set the true solution for training and validation
                    interior = set_interior(f_nodes)

                    # Write the grid coordinates, training and validation data
                    if i < training_size:
                        np.savetxt(f1, features)
                        np.savetxt(f2, interior)
                    else:
                        np.savetxt(f3, features)
                        np.savetxt(f4, interior)
                    '''
                    plt.title("Temperature contour: Numerical Solution Data- ")
                    colorinterpolation = 50
                    colourMap = plt.cm.jet
                    plt.contourf(xx, yy, f_nodes, colorinterpolation, cmap=colourMap)
                    cb1 = plt.colorbar()
                    plt.show()
                    '''


# Sanity Checks: All look good!
'''
    print(z)
    print(Left)
    print(Right)
    print(Top)
    print(Bottom)
    print(boundary)
    print(interior)
'''

# Plotting routines
'''
ax = plt.axes(projection='3d')
ax.plot_surface(xx, yy, f_nodes)
ax.set_xlabel('x')
ax.set_ylabel('y')
ax.set_zlabel('f(x,y)')
plt.show()
'''
